#define I2C_SLAVE_ADDRESS 0x12

#define SERVO_PIN 1

#include <TinyWireS.h>
// The default buffer size, Can't recall the scope of defines right now
#ifndef TWI_RX_BUFFER_SIZE
#define TWI_RX_BUFFER_SIZE ( 16 )
#endif

int product_id = 2048;
byte product_id_8bit[4];

int byteSent = 0;

int state = 0;

// For the servo
int lastServo = 0;
int pulseStarted = 0;
int pulseDuration = 1;

int servo_position = 600;
bool isPulsing = false;

void requestEvent()
{
  
}

void receiveEvent(uint8_t howMany)
{
    if (howMany < 1)
    {
        // Sanity-check
        return;
    }
    if (howMany > TWI_RX_BUFFER_SIZE)
    {
        // Also insane number
        return;
    }
    
    int x = TinyWireS.receive();
    if ( state == 10 ) {
      //dispense(x);
      state = 0;
    } else {
      state = x;
      byteSent = 0;
    }
}


void setup()
{
    pinMode(SERVO_PIN, OUTPUT);
    
    TinyWireS.begin(I2C_SLAVE_ADDRESS);
    TinyWireS.onReceive(receiveEvent);
    TinyWireS.onRequest(requestEvent);
}


void loop()
{
    TinyWireS_stop_check();
    servo_clock();
}

int pct_to_servo( int servo_percent )
{
  int servo_setpoint = map(servo_percent, 0, 100, 500, 2500);
}

void servo_clock()
{
  if ( (millis() - lastServo) >= 20 )
  {
    lastServo = millis();
    digitalWrite(SERVO_PIN, HIGH);
    delayMicroseconds(servo_position);
    digitalWrite(SERVO_PIN, LOW);
  }
}

//Carve up the 32 bit integers into a byte array for easy sending over TWI
void splitints()
{
  product_id_8bit[0]=(product_id >>24) & 0xff;
  product_id_8bit[1]=(product_id >>16) & 0xff;
  product_id_8bit[2]=(product_id >>8) & 0xff;
  product_id_8bit[3]=product_id & 0xff;
}
